@startuml
title 2h orderGenericStep
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "kitchenJobManager.currentKitchenJob:KitchenJob" as kj
participant "group: GroupStep" as g
participant "childrens: List<GenericStep>" as childs
participant "r: KitchenJobReceiver" as r
Actor -> kjm ++:orderGenericStep(step,group,position)

alt currentKitchenJob == null
  kjm -->> Actor: throw UseCaseLogicException
else position < 0 || \n position >= childrens.size()
  kjm -->> Actor:throw OutOfBoundException	
else
  kjm -> kj ++: orderGenericStep(step,group,position)
  kj -> g ++:removeChildren(step)
  g ->childs ++: remove(step)
  deactivate childs
  deactivate g
  'Aggiungo addChildren con parametro anche position o avete soluzioni migliori
  kj -> g ++: addChildren(step,position)
  g ->childs ++: add(step,position)
  deactivate childs
  deactivate g
  kj -->> kjm
  deactivate kj
  group for each r in receivers
    kjm -> r++:notifyGenericStepRearrangedKitchenJob(currentKitchenJob,step)
    deactivate r
  end
  kjm -->> Actor
  deactivate kjm
end
@enduml
